extends Camera3D

@export var target:NodePath


var target_object:Node3D 

@export var offset:Vector3 = Vector3(0, 1.5, 0)
var radius:float

var source_position:Vector3
var angle

var target_position: Vector3

var rotation_speed: float = 1

# Called when the node enters the scene tree for the first time.
func _ready():
	target_object = get_node(target)
	
	radius = target_object.position.distance_to(self.position)
	
	self.look_at(target_object.position + offset, Vector3.UP)
	
	source_position = self.position
	
	target_position = source_position
	
# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	if Input.is_key_pressed(KEY_RIGHT):
		target_position = target_position.rotated(Vector3.UP, -delta*rotation_speed)
		
	if Input.is_key_pressed(KEY_LEFT):
		target_position = target_position.rotated(Vector3.UP, delta*rotation_speed)
	
	self.position = lerp(self.position, target_position, delta)
	
	self.look_at_from_position(self.position, target_object.position + offset, Vector3.UP)

func _input(event):
	if event is InputEventScreenDrag:
		target_position = target_position.rotated(Vector3.UP, -event.relative.x/500 )
