extends Node

@export var targetFPS:int = 30
@export var minimumScale:float = 0.5
@export var sampleFrames:int = 120
@export var pauseFrames:int = 30

var values: Array = []

var vp: Viewport

var currentFrame = 0

# Called when the node enters the scene tree for the first time.
func _ready():
	vp = get_viewport()


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	
	if len(values) < sampleFrames:
		values.append(Engine.get_frames_per_second())
	else:
		values.push_front(Engine.get_frames_per_second())
		values.pop_back()
		
		currentFrame += 1
		
		if currentFrame >= pauseFrames:
			currentFrame = 0
			var avg = 0
			
			for v in values:
				avg += v
				
			avg = avg / len(values)

			if avg > targetFPS*2 and vp.scaling_3d_scale < 1:
				vp.scaling_3d_scale = min(vp.scaling_3d_scale/0.95, 1)
				values = []
				print("Adjusting resolution up - %f" % vp.scaling_3d_scale)
				
			if avg < targetFPS*0.8 and vp.scaling_3d_scale > minimumScale:
				vp.scaling_3d_scale = vp.scaling_3d_scale*0.95
				values = []
				print("Adjusting resolution down - %f" % vp.scaling_3d_scale)
